# IBM Worklight Server installation/uninstallation script for
# WebSphere Application Server.
#
# Licensed Materials - Property of IBM
# 5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#

import fnmatch
import glob
import os
import sys

if len(sys.argv) > 0:
	# Note: On Unix, wsadmin does not accept empty arguments.
	# Arguments that start with a minus sign are dangerous as well.
	# Therefore all arguments are prefixed with '='.

	operation                                = sys.argv[0] [1:]

	appserver_selection                      = sys.argv[1] [1:]
	appserver_was_installdir                 = sys.argv[2] [1:]
	appserver_was_profile                    = sys.argv[3] [1:]
	appserver_was_profile_dir                = sys.argv[4] [1:]
	appserver_was_cell                       = sys.argv[5] [1:]
	appserver_was_node                       = sys.argv[6] [1:]
	appserver_was_scope                      = sys.argv[7] [1:]
	appserver_was_serverInstance             = sys.argv[8] [1:]
	appserver_was_nd_cluster                 = sys.argv[9] [1:]
	appserver_was_nd_node                    = sys.argv[10] [1:]
	appserver_was_nd_server                  = sys.argv[11] [1:]
	appserver_was_admin_name                 = sys.argv[12] [1:]
	appserver_was_admin_password             = sys.argv[13] [1:]
	appserver_was_appcenteradmin_password    = sys.argv[14] [1:]
	database_selection                       = sys.argv[15] [1:]
	database_preinstalled                    = sys.argv[16] [1:]
	database_derby_datadir                   = sys.argv[17] [1:]
	database_db2_host                        = sys.argv[18] [1:]
	database_db2_port                        = sys.argv[19] [1:]
	database_db2_driver                      = sys.argv[20] [1:]
	database_db2_worklight_admin_name        = sys.argv[21] [1:]
	database_db2_worklight_admin_password    = sys.argv[22] [1:]
	database_mysql_host                      = sys.argv[23] [1:]
	database_mysql_port                      = sys.argv[24] [1:]
	database_mysql_driver                    = sys.argv[25] [1:]
	database_mysql_worklight_admin_name      = sys.argv[26] [1:]
	database_mysql_worklight_admin_password  = sys.argv[27] [1:]
	database_oracle_host                     = sys.argv[28] [1:]
	database_oracle_port                     = sys.argv[29] [1:]
	database_oracle_driver                   = sys.argv[30] [1:]
	database_oracle_worklight_admin_name     = sys.argv[31] [1:]
	database_oracle_worklight_admin_password = sys.argv[32] [1:]

	worklight_war                            = sys.argv[33] [1:]
	worklight_war_basename                   = sys.argv[34] [1:]
	worklight_war_context                    = sys.argv[35] [1:]
	worklight_war_appname                    = sys.argv[36] [1:]
	worklight_lib                            = sys.argv[37] [1:]
	worklight_lib_basename                   = sys.argv[38] [1:]

	appcenter_console_war                    = sys.argv[39] [1:]
	appcenter_console_war_basename           = sys.argv[40] [1:]
	appcenter_console_war_context            = sys.argv[41] [1:]
	appcenter_console_war_appname            = sys.argv[42] [1:]
	appcenter_services_war                   = sys.argv[43] [1:]
	appcenter_services_war_basename          = sys.argv[44] [1:]
	appcenter_services_war_context           = sys.argv[45] [1:]
	appcenter_services_war_appname           = sys.argv[46] [1:]
	derby_lib                                = sys.argv[47] [1:]
	derby_lib_basename                       = sys.argv[48] [1:]

	worklight_database_name                  = sys.argv[49] [1:]
	worklightreports_database_name           = sys.argv[50] [1:]
	appcenter_database_name                  = sys.argv[51] [1:]

	database_worklight_admin_name            = sys.argv[52] [1:]
	database_worklight_admin_password        = sys.argv[53] [1:]

	database_derby_driverclass               = sys.argv[54] [1:]
	database_db2_uri                         = sys.argv[55] [1:]
	database_db2_driverclass                 = sys.argv[56] [1:]
	database_mysql_uri                       = sys.argv[57] [1:]
	database_mysql_driverclass               = sys.argv[58] [1:]
	database_oracle_uri                      = sys.argv[59] [1:]
	database_oracle_driverclass              = sys.argv[60] [1:]
	database_db2_driver_dir                  = sys.argv[61] [1:]

	worklight_database_schema                = sys.argv[62] [1:]
	worklightreports_database_schema         = sys.argv[63] [1:]
	appcenter_database_schema                = sys.argv[64] [1:]

	worklight_database_jdbc_url              = sys.argv[65] [1:]
	worklightreports_database_jdbc_url       = sys.argv[66] [1:]
	appcenter_database_jdbc_url              = sys.argv[67] [1:]

	worklight_database_jndi_name             = sys.argv[68] [1:]
	worklightreports_database_jndi_name      = sys.argv[69] [1:]
	appcenter_database_jndi_name             = sys.argv[70] [1:]

	appserver_resourcesdir                   = sys.argv[71] [1:]
	appserver_was_aapt_dir                   = sys.argv[72] [1:]

	appserver_was_serial                     = sys.argv[73] [1:]

else:
	# Settings for Bruno's testing.

	operation = 'install'

	appserver_selection = 'was'
	appserver_was_installdir = '/n/java/webservers/was-8.0-express'
	appserver_was_profile = 'AppSrv01'
	appserver_was_profile_dir = '/n/java/webservers/was-8.0-express/profiles/AppSrv01'
	appserver_was_cell = 'bordeauxNode02Cell'
	appserver_was_node = 'bordeauxNode02'
	appserver_was_scope = 'server'
	appserver_was_serverInstance = 'server1'
	appserver_was_nd_cluster = ''
	appserver_was_nd_node = ''
	appserver_was_nd_server = ''
	appserver_was_admin_name = 'admin'
	appserver_was_admin_password = 'admin'
	appserver_was_appcenteradmin_password = 'rdeouiruwoir'
	database_selection = 'derby'
	database_preinstalled = 'false'
	database_derby_datadir = '/var/ibm/Worklight/derby'
	database_db2_host = ''
	database_db2_port = ''
	database_db2_driver = ''
	database_db2_worklight_admin_name = ''
	database_db2_worklight_admin_password = ''
	database_mysql_host = ''
	database_mysql_port = ''
	database_mysql_driver = ''
	database_mysql_worklight_admin_name = ''
	database_mysql_worklight_admin_password = ''
	database_oracle_host = ''
	database_oracle_port = ''
	database_oracle_driver = ''
	database_oracle_worklight_admin_name = ''
	database_oracle_worklight_admin_password = ''

	worklight_war = '/n/distrib/wl-mfee-5001-server/WorklightServer/worklight.war'
	worklight_war_basename = 'worklight.war'
	worklight_war_context = '/worklight'
	worklight_war_appname = 'IBM_Worklight_Console'
	worklight_lib = 'worklight-jee-library.jar'
	worklight_lib_basename = 'worklight-jee-library.jar'

	appcenter_console_war = '/n/distrib/wl-mfee-5001-server/WorklightServer/../ApplicationCenter/console/appcenterconsole.war'
	appcenter_console_war_basename = 'appcenterconsole.war'
	appcenter_console_war_context = '/appcenterconsole'
	appcenter_console_war_appname = 'IBM_Application_Center_Console'
	appcenter_services_war = '/n/distrib/wl-mfee-5001-server/WorklightServer/../ApplicationCenter/console/applicationcenter.war'
	appcenter_services_war_basename = 'applicationcenter.war'
	appcenter_services_war_context = '/applicationcenter'
	appcenter_services_war_appname = 'IBM_Application_Center_Services'
	derby_lib = 'install/derby.jar'
	derby_lib_basename = 'derby.jar'

	worklight_database_name = 'WRKLGHT'
	worklightreports_database_name = 'WLREPORT'
	appcenter_database_name = 'APPCNTR'

	database_worklight_admin_name = 'foo'
	database_worklight_admin_password = ''

	database_derby_driverclass = 'org.apache.derby.jdbc.EmbeddedDriver'
	database_db2_uri = ''
	database_db2_driverclass = 'com.ibm.db2.jcc.DB2Driver'
	database_mysql_uri = ''
	database_mysql_driverclass = 'com.mysql.jdbc.Driver'
	database_oracle_uri = ''
	database_oracle_driverclass = 'oracle.jdbc.OracleDriver'
	database_db2_driver_dir = '/n/home/haible/worklight/db2-svt'

	worklight_database_schema = 'WORKLIGHT'
	worklightreports_database_schema = 'WORKLIGHT'
	appcenter_database_schema = 'PUREMEAP'

	worklight_database_jdbc_url = 'jdbc:derby:/var/ibm/Worklight/derby/WRKLGHT'
	worklightreports_database_jdbc_url = 'jdbc:derby:/var/ibm/Worklight/derby/WLREPORT'
	appcenter_database_jdbc_url = 'jdbc:derby:/var/ibm/Worklight/derby/APPCNTR'

	worklight_database_jndi_name = 'jdbc/WorklightDS'
	worklightreports_database_jndi_name = 'jdbc/WorklightReportsDS'
	appcenter_database_jndi_name = 'jdbc/AppCenterDS'

	appserver_resourcesdir = 'config/Worklight-5.0'
	appserver_was_aapt_dir = appserver_resourcesdir + '/android-sdk'

	appserver_was_serial = '7560103198'

# Jython is Python 2.1 compatible, which did not have the boolean type.
True = 1
False = 0

# Determine whether the server (nodeName, serverName) is member of some cluster.
def isInCluster(nodeName, serverName):
	for clusterObject in AdminUtilities.convertToList(AdminConfig.list('ServerCluster')):
		# clusterObject is of type ServerCluster.
		for memberObject in AdminUtilities.convertToList(AdminConfig.showAttribute(clusterObject, 'members')):
			# memberObject is of type ClusterMember.
			if nodeName == AdminConfig.showAttribute(memberObject, 'nodeName'):
				if serverName == AdminConfig.showAttribute(memberObject, 'memberName'):
					return True
	return False

# Test whether WAS 8.0 or newer is used.
was8 = not glob.glob(appserver_was_installdir + os.sep + 'features' + os.sep + 'com.ibm.ws.osgi.applications_*') == []

# Scope dependent variables:
#
# appserver_was_scope == 'server':
#   means an unmanaged (isolated) server.
#   Extra variables: appserver_was_serverInstance.
#
# The other cases assume a cell and a deployment manager.
#
# appserver_was_scope == 'nd-cell':
#   means the entire cell.
#
# appserver_was_scope == 'nd-cluster':
#   means a cluster in the cell.
#   Extra variables: appserver_was_nd_cluster.
#
# appserver_was_scope == 'nd-node':
#   means a node in the cell.
#   Extra variables: appserver_was_nd_node.
#
# appserver_was_scope == 'nd-server':
#   means a server in a node in the cell.
#   Extra variables: appserver_was_nd_node, appserver_was_nd_server.

# Derived variables.

# affected_servers is the set of servers (tuples (node name, server name))
# which are affected by the operation.
# Note! A server name is not sufficient to identify a server:
# Different servers in different nodes can have the same name. But the pair
# (node name, server name) is sufficient.
affected_servers = []
if appserver_was_scope == 'server':
	affected_servers.append((appserver_was_node, appserver_was_serverInstance))
elif appserver_was_scope == 'nd-cell':
	cellObject = AdminConfig.getid('/Cell:' + appserver_was_cell + '/')
	if cellObject == '':
		raise 'Cell ' + appserver_was_cell + ' not found!'
	# cellObject is of type Cell.
	for nodeObject in AdminUtilities.convertToList(AdminConfig.list('Node', cellObject)):
		# nodeObject is of type Node.
		nodeName = AdminConfig.showAttribute(nodeObject, 'name')
		if nodeName != '':
			for serverObject in AdminUtilities.convertToList(AdminConfig.list('Server', nodeObject)):
				# serverObject is of type Server.
				# Include only those with serverType = 'APPLICATION_SERVER';
				# exclude those with serverType = 'DEPLOYMENT_MANAGER' or
				# = 'NODE_AGENT'.
				# Alternatively, we could also look at the components attribute
				# and exclude those which have a component of type CellManager
				# or a component of type NodeAgent.
				if AdminConfig.showAttribute(serverObject, 'serverType') == 'APPLICATION_SERVER':
					serverName = AdminConfig.showAttribute(serverObject, 'name')
					if serverName != '':
						affected_servers.append((nodeName, serverName))
elif appserver_was_scope == 'nd-cluster':
	clusterObject = AdminConfig.getid('/ServerCluster:' + appserver_was_nd_cluster + '/')
	if clusterObject == '':
		raise 'Cluster ' + appserver_was_nd_cluster + ' not found!'
	# clusterObject is of type ServerCluster.
	for memberObject in AdminUtilities.convertToList(AdminConfig.showAttribute(clusterObject, 'members')):
		# memberObject is of type ClusterMember.
		nodeName = AdminConfig.showAttribute(memberObject, 'nodeName')
		serverName = AdminConfig.showAttribute(memberObject, 'memberName')
		server = (nodeName, serverName)
		if not server in affected_servers:
			affected_servers.append(server)
elif appserver_was_scope == 'nd-node':
	nodeObject = AdminConfig.getid('/Node:' + appserver_was_nd_node + '/')
	if nodeObject == '':
		raise 'Node ' + appserver_was_nd_node + ' not found!'
	# nodeObject is of type Node.
	for serverObject in AdminUtilities.convertToList(AdminConfig.list('Server', nodeObject)):
		# serverObject is of type Server.
		# Include only those with serverType = 'APPLICATION_SERVER';
		# exclude those with serverType = 'DEPLOYMENT_MANAGER' or
		# = 'NODE_AGENT'.
		# Alternatively, we could also look at the components attribute
		# and exclude those which have a component of type CellManager
		# or a component of type NodeAgent.
		if AdminConfig.showAttribute(serverObject, 'serverType') == 'APPLICATION_SERVER':
			serverName = AdminConfig.showAttribute(serverObject, 'name')
			# Exclude servers that are part of a cluster, because WAS
			# does not allow to install an application on a server that is
			# part of a cluster without installing it on the entire cluster,
			# and the cluster can contain servers on different nodes.
			if serverName != '' and not isInCluster(appserver_was_nd_node, serverName):
				affected_servers.append((appserver_was_nd_node, serverName))
elif appserver_was_scope == 'nd-server':
	serverObject = AdminConfig.getid('/Node:' + appserver_was_nd_node + '/Server:' + appserver_was_nd_server + '/')
	if serverObject == '':
		raise 'Server ' + appserver_was_nd_server + ' not found in node ' + appserver_was_nd_node + '!'
	affected_servers.append((appserver_was_nd_node, appserver_was_nd_server))
print 'was-install.py determined set of affected servers:'
print affected_servers

# affected_nodes is the set of nodes (node names) which are affected by the
# operation.
affected_nodes = []
if appserver_was_scope == 'server':
	affected_nodes.append(appserver_was_node)
else:
	for server in affected_servers:
		(nodeName, serverName) = server
		if not nodeName in affected_nodes:
			affected_nodes.append(nodeName)
print 'was-install.py determined set of affected nodes:'
print affected_nodes

# scopeContainmentPath is a hierarchical search request that can be passed to AdminConfig.getid.
# scopeParam is a scope parameter for AdminTask.createJDBCProvider.
# scopeObject is an object that represents the entire scope (of type Server,
# Cell, ServerCluster, or Node).
if appserver_was_scope == 'server':
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/Node:' + appserver_was_node + '/Server:' + appserver_was_serverInstance + '/'
	scopeParam = 'Node=' + appserver_was_node + ',Server=' + appserver_was_serverInstance
elif appserver_was_scope == 'nd-cell':
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/'
	scopeParam = 'Cell=' + appserver_was_cell
elif appserver_was_scope == 'nd-cluster':
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/ServerCluster:' + appserver_was_nd_cluster + '/'
	scopeParam = 'Cluster=' + appserver_was_nd_cluster
elif appserver_was_scope == 'nd-node':
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/Node:' + appserver_was_nd_node + '/'
	scopeParam = 'Node=' + appserver_was_nd_node
elif appserver_was_scope == 'nd-server':
	scopeContainmentPath = '/Cell:' + appserver_was_cell + '/Node:' + appserver_was_nd_node + '/Server:' + appserver_was_nd_server + '/'
	scopeParam = 'Node=' + appserver_was_nd_node + ',Server=' + appserver_was_nd_server
scopeObject = AdminConfig.getid(scopeContainmentPath)

print 'was-install.py scope setting:'
print scopeContainmentPath
print scopeParam
print scopeObject
print AdminConfig.show(scopeObject)
print

# appname_suffix is the suffix used to distinguish applications
# from different Worklight Server installations (for different
# nodes, clusters, or servers, in the same cell).
if appserver_was_scope[0:3] == 'nd-':
	appname_suffix = '_' + appserver_was_serial
else:
	appname_suffix = ''
# Add this suffix to all application names.
worklight_war_appname = worklight_war_appname + appname_suffix
appcenter_console_war_appname = appcenter_console_war_appname + appname_suffix
appcenter_services_war_appname = appcenter_services_war_appname + appname_suffix

# authenticationAlias is the name of the authentication alias
# (= credentials for a datasource).
if database_selection == 'derby' or database_selection == 'mysql' or database_selection == 'oracle':
	authenticationAlias = ''
else:
	authenticationAlias = 'Worklight' + database_selection.capitalize() + 'DatabaseCredentials'
	if appserver_was_scope[0:3] == 'nd-':
		# We add a serial number as suffix, so that multiple Worklight Server
		# installations, each for a different cluster or a different node,
		# can coexist in the same cell.
		authenticationAlias = authenticationAlias + '_' + appserver_was_serial

# Tests whether an authentication alias with the given name exists.
def authAliasExistsBAD(name):
	# Using AdminTask.getAuthDataEntry is bad because
	# - It leaves an exception in the log if the entry does not exist.
	# - In WAS 7.0, when invoked with argument ['-alias', name], the
	#   function may return the alias with name node+'/'+name.
	try:
		return AdminTask.getAuthDataEntry(['-alias', name]) != ''
	except:
		# Note: This leaves an exception
		#   FFDC Exception:com.ibm.websphere.management.cmdframework.CommandValidationException
		#   SECJ7732E: The specified auth data entry does not exist.
		# in the server's log, but it can be ignored.
		return False
def authAliasExists(name):
	for authEntry in AdminUtilities.convertToList(AdminConfig.list('JAASAuthData')):
		# authEntry is of type JAASAuthData.
		alias = AdminConfig.showAttribute(authEntry, 'alias')
		if alias != None and alias == name:
			return True
	return False

# Returns the AdminConfig object for an authentication alias with the given name.
# The result is of type JAASAuthData or empty.
def getAuthDataEntryObject(name):
	for authEntry in AdminUtilities.convertToList(AdminConfig.list('JAASAuthData')):
		# authEntry is of type JAASAuthData.
		alias = AdminConfig.showAttribute(authEntry, 'alias')
		if alias != None and alias == name:
			return authEntry
	return ''

# Execute a "full synchronize".
# Documentation:
# http://www-01.ibm.com/support/docview.wss?uid=swg21108407
# http://www-01.ibm.com/support/docview.wss?uid=swg21233075
def fullSync():
	print 'was-install.py doing full synchronize...'
	# This is the old way (http://www.vm.ibm.com/events/2005-W25.PDF).
	#for node in affected_nodes:
	#	nodeSyncObject = AdminControl.completeObjectName('type=NodeSync,cell=' + appserver_was_cell + ',node=' + node + ',*')
	#	# For the node which contains just the deployment manager, nodeSyncObject is empty.
	#	if nodeSyncObject != '':
	#		AdminControl.invoke(nodeSyncObject, 'sync')
	# This is the way suggested by the WAS administrative console.
	for node in affected_nodes:
		configRepositoryObject = AdminControl.completeObjectName('type=ConfigRepository,name=repository,process=nodeagent,cell=' + appserver_was_cell + ',node=' + node + ',*')
		if configRepositoryObject != '':
			AdminControl.invoke(configRepositoryObject, 'refreshRepositoryEpoch')
	cellSyncObject = AdminControl.completeObjectName('type=CellSync,name=cellSync,process=dmgr,cell=' + appserver_was_cell + ',*')
	if cellSyncObject != '':
		for node in affected_nodes:
			AdminControl.invoke(cellSyncObject, 'syncNode', '[' + node + ']', '[java.lang.String]')
	print 'was-install.py full synchronize done'


if operation == 'install':


	if appserver_was_scope[0:3] == 'nd-':
		# Execute a "full synchronize" of the resources to all nodes.
		fullSync()

	# ======================== Configuration for Worklight ========================

	# Creates an AdminConfig object for an authentication alias with the given name
	# with the given user name, password, and description.
	def createAuthDataEntryObjectBAD(name, user, password, description):
		# Using AdminTask.createAuthDataEntry is a bad idea, because
		# - In WAS 7.0, and
		# - in WAS 8.x when the checkbox "Prefix new alias names with the node
		#   name of the cell (for compatibility with earlier releases)" is enabled,
		#   i.e. property com.ibm.websphere.security.JAASAuthData.removeNodeNameGlobal
		#   has the value "false",
		# the alias name is prefixed with the node name of the cell implicitly.
		# This makes no sense, because the alias is attached to the cell. And
		# the behaviour depends on WAS version and user settings.
		AdminTask.createAuthDataEntry([
			'-alias', name,
			'-user', 'dummy',
			'-password', 'dummy'
		])
		# This statement depends on WAS version and user settings!
		name = appserver_was_node + '/' + name
		# Use AdminConfig.modify to set the password, because
		# AdminTask.createAuthDataEntry and AdminTask.modifyAuthDataEntry
		# don't support passwords that contain a '"' character.
		entryObject = getAuthDataEntryObject(name)
		if entryObject == '':
			raise "could not create authentication alias '" + name + "'"
		# entryObject is of type JAASAuthData.
		AdminConfig.modify(entryObject, [
			['userId', user],
			['password', password],
			['description', description]
		])
	def createAuthDataEntryObject(name, user, password, description):
		# Use AdminConfig.
		securityObject = AdminConfig.getid('/Cell:' + appserver_was_cell + '/Security:/')
		if securityObject == '':
			raise "could not find Security object for cell '" + appserver_was_cell + "'"
		# securityObject is of type Security.
		AdminConfig.create('JAASAuthData', securityObject, [
			['alias', name],
			['userId', user],
			['password', password],
			['description', description]
		])

	# Ensures an authentication alias with the given attributes exists.
	def ensureAuthAlias(name, user, password, description):
		# If the authentication alias does not already exist, create it,
		# otherwise modify it.
		entryObject = getAuthDataEntryObject(name)
		if entryObject == '':
			createAuthDataEntryObject(name, user, password, description)
			entryObject = getAuthDataEntryObject(name)
			if entryObject == '':
				raise "could not create authentication alias '" + name + "'"
		else:
			AdminConfig.modify(entryObject, [
				['userId', user],
				['password', password],
				['description', description]
			])

	# Create the authentication alias (= credentials for a datasource).
	# Documentation of the entirely bad AdminTask.*AuthDataEntry API:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_7securityconfig.html
	print 'was-install.py creating authentication alias...'
	if authenticationAlias != '':
		description = 'used by the Worklight JDBC data sources'
		ensureAuthAlias(authenticationAlias, database_worklight_admin_name, database_worklight_admin_password, description)
	print 'was-install.py creating authentication alias done'
	print authenticationAlias
	print

	# Create the JDBC provider.
	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atjdbcprovider.html
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frdat_minreq.html

	# Converts a list of filenames to classpath syntax.
	# This function deals with two problems:
	# 1. conversion of the filenames to slashified syntax,
	# 2. when a filename contains a space, this space should not be viewed as a separator
	#    between classpath elements.
	def convertListToClasspath(l):
		s = ''
		for x in l:
			s += '"' + x.replace(os.sep, '/') + '"' + ' '
		if s != '':
			s = s[0:len(s)-1]
		return '[' + s + ']'

	# Returns the set of files that matches a given pattern, in a given
	# subdirectory of appserver_was_profile_dir, replacing
	# appserver_was_profile_dir with ${USER_INSTALL_ROOT} in the result.
	def glob_in_profile_dir(relativeDirName, pattern):
		l = []
		for fileName in os.listdir(appserver_was_profile_dir + '/' + relativeDirName):
			if fnmatch.fnmatch(fileName, pattern):
				l.append('${USER_INSTALL_ROOT}/' + relativeDirName + '/' + fileName)
		return l

	# Ensures a given JDBC provider object exists.
	def ensureJDBCProvider(jdbcProviderName, description, database_selection):
		implementationClassName = ''
		if database_selection == 'derby':
			databaseType = 'Derby'
			providerType = 'Derby JDBC Provider 40'
			implementationType = 'Connection pool data source'
			implementationClassName = 'org.apache.derby.jdbc.EmbeddedConnectionPoolDataSource40' # inferred by createJDBCProvider
			classpath = [ '${USER_INSTALL_ROOT}/' + appserver_resourcesdir + '/derby/' + derby_lib_basename ]
		elif database_selection == 'db2':
			databaseType = 'DB2'
			providerType = 'DB2 Universal JDBC Driver Provider'
			implementationType = 'Connection pool data source'
			implementationClassName = 'com.ibm.db2.jcc.DB2ConnectionPoolDataSource' # inferred by createJDBCProvider
			classpath = glob_in_profile_dir(appserver_resourcesdir + '/db2', '*.jar')
		elif database_selection == 'mysql':
			databaseType = 'User-defined'
			providerType = 'User-defined JDBC Provider'
			implementationType = 'User-defined'
			implementationClassName = 'com.mysql.jdbc.jdbc2.optional.MysqlConnectionPoolDataSource'
			classpath = glob_in_profile_dir(appserver_resourcesdir + '/mysql', '*.jar')
		elif database_selection == 'oracle':
			databaseType = 'Oracle'
			providerType = 'Oracle JDBC Driver'
			implementationType = 'Connection pool data source'
			implementationClassName = 'oracle.jdbc.pool.OracleConnectionPoolDataSource' # inferred by createJDBCProvider
			classpath = glob_in_profile_dir(appserver_resourcesdir + '/oracle', '*.jar')
		else:
			raise "unsupported database type"
		# If the JDBC provider does not already exist, create it,
		# otherwise modify it.
		jdbcProviderObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/')
		if jdbcProviderObject != '' and AdminConfig.showAttribute(jdbcProviderObject, 'providerType') != providerType:
			# Since 'providerType' is a read-only attribute, there is no way to change it.
			# So remove the JDBC provider.
			# AdminTask.deleteJDBCProvider was only introduced in WAS 8.0.
			if was8:
				AdminTask.deleteJDBCProvider(jdbcProviderObject)
			else:
				AdminConfig.remove(jdbcProviderObject)
			jdbcProviderObject = ''
		if jdbcProviderObject == '':
			print 'was-install.py creating JDBC provider...'
			AdminTask.createJDBCProvider([
				'-scope', scopeParam,
				'-databaseType', databaseType,
				'-providerType', providerType,
				'-implementationType', implementationType,
				'-implementationClassName', implementationClassName,
				'-classpath', convertListToClasspath(classpath),
				'-name', jdbcProviderName,
				'-description', description,
				'-isolated', 'true', # Avoid version conflicts with other JDBC providers
				'-nativePath', '' # Needed for -isolated true
			])
		else:
			# Note that the properties databaseType and implementationType are
			# not actually stored in the jdbcProviderObject.
			print 'was-install.py updating JDBC provider...'
			AdminConfig.modify(
				jdbcProviderObject,
				[
					# ADMG0014E: Attribute providerType is a read-only attribute.
					#['providerType', providerType],
					['implementationClassName', implementationClassName],
					# The extra space works around a "WASX7123E: Unexpected "]" found" error.
					# See the tech note "AdminConfig.modify() fails with WASX7123E: Unexpected "]" found error"
					# http://www-01.ibm.com/support/docview.wss?uid=swg21587193
					['classpath', ' ' + convertListToClasspath(classpath)],
					['name', jdbcProviderName],
					['description', description],
					['isolatedClassLoader', 'true'],
					['nativepath', '']
				]);
		jdbcProviderObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/')
		print 'was-install.py JDBC provider done'
		print AdminConfig.show(jdbcProviderObject)
		print
		return jdbcProviderObject

	jdbcProviderName = 'Worklight JDBC Provider'
	description = 'JDBC provider for the IBM Worklight databases'
	jdbcProviderObject = ensureJDBCProvider(jdbcProviderName, description, database_selection)

	# Create the datasources.
	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atjdbcprovider.html

	# Shows the contents of a J2EEResourcePropertySet object.
	def showJ2EEResourcePropertySet(obj):
		for prop in AdminUtilities.convertToList(AdminConfig.showAttribute(obj, 'resourceProperties')):
			print prop
			print AdminConfig.showAttribute(prop, 'name')
			print AdminConfig.showAttribute(prop, 'value')
			print

	# Finds a property with the given name in a J2EEResourcePropertySet object.
	def hasJ2EEResourcePropertySetProperty(obj, name):
		for prop in AdminUtilities.convertToList(AdminConfig.showAttribute(obj, 'resourceProperties')):
			if AdminConfig.showAttribute(prop, 'name') == name:
				return prop
		return None

	# Ensures a J2EEResourcePropertySet object has a given property given by (name, tipe, value).
	def setJ2EEResourcePropertySetProperty(obj, name, tipe, value):
		propertyObject = hasJ2EEResourcePropertySetProperty(obj, name)
		if propertyObject == None:
			AdminConfig.create('J2EEResourceProperty', obj,
				[
					['name', name],
					['type', tipe],
					['value', value]
				])
		else:
			AdminConfig.modify(propertyObject,
				[
					['type', tipe],
					['value', value]
				])

	# Ensures that a resource object (e.g. a datasource object) has the given
	# custom properties as J2EEResourcePropertySet.
	def ensureJ2EEResourceProperties(resourceObject, customProperties):
		j2eePropertiesObject = AdminConfig.showAttribute(resourceObject, 'propertySet')
		if j2eePropertiesObject == None:
			j2eePropertiesObject = AdminConfig.create('J2EEResourcePropertySet', resourceObject, [])
		for customProperty in customProperties:
			setJ2EEResourcePropertySetProperty(j2eePropertiesObject,
				customProperty[0], customProperty[1], customProperty[2])
		#print AdminConfig.show(j2eePropertiesObject)
		#print
		#showJ2EEResourcePropertySet(j2eePropertiesObject)

	# Ensures a given datasource object exists.
	def ensureDatabase(datasourceName, description, database_selection, jndiName, database_name, database_jdbc_url, database_schema, authenticationAlias):
		if database_selection == 'derby':
			dataStoreHelperClassName = 'com.ibm.websphere.rsadapter.DerbyDataStoreHelper'
			properties = [
				['databaseName', 'java.lang.String', database_derby_datadir + '/' + database_name]
			]
			customProperties = [
				['user', 'java.lang.String', database_schema],
				['password', 'java.lang.String', '']
			]
		elif database_selection == 'db2':
			dataStoreHelperClassName = 'com.ibm.websphere.rsadapter.DB2UniversalDataStoreHelper'
			properties = [
				['driverType', 'java.lang.Integer', '4'],
				['serverName', 'java.lang.String', database_db2_host],
				['portNumber', 'java.lang.Integer', database_db2_port],
				['databaseName', 'java.lang.String', database_name]
			]
			customProperties = [
			]
		elif database_selection == 'mysql':
			dataStoreHelperClassName = 'com.ibm.websphere.rsadapter.GenericDataStoreHelper'
			properties = [
			]
			customProperties = [
				['serverName', 'java.lang.String', database_mysql_host],
				['portNumber', 'java.lang.Integer', database_mysql_port],
				['databaseName', 'java.lang.String', database_name],
				['user', 'java.lang.String', database_worklight_admin_name],
				['password', 'java.lang.String', database_worklight_admin_password],
				['nonTransactionalDataSource', 'java.lang.Boolean', 'true'],
				# Avoid runtime errors like
				# java.sql.SQLException: Can't call rollback when autocommit=true
				# java.sql.SQLException: Error open transaction is not closed
				# See <http://docs.oracle.com/cd/E19226-01/820-7695/gbhbr/index.html>.
				['relaxAutoCommit', 'java.lang.Boolean', 'true']
			]
		elif database_selection == 'oracle':
			dataStoreHelperClassName = 'com.ibm.websphere.rsadapter.Oracle11gDataStoreHelper'
			properties = [
				['URL', 'java.lang.String', database_jdbc_url]
			]
			customProperties = [
				#['portNumber', 'java.lang.Integer', database_oracle_port], # redundant
				#['databaseName', 'java.lang.String', database_name], # redundant
				['user', 'java.lang.String', database_worklight_admin_name],
				['password', 'java.lang.String', database_worklight_admin_password]
			]
		else:
			raise "unsupported database type"
		# If the data source does not already exist, create it,
		# otherwise modify it.
		datasourceObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/DataSource:' + datasourceName + '/')
		if datasourceObject != '' and AdminConfig.showAttribute(datasourceObject, 'providerType') != AdminConfig.showAttribute(jdbcProviderObject, 'providerType'):
			# Since 'providerType' is a read-only attribute, there is no way to change it.
			# So remove the datasource.
			# AdminTask.deleteDatasource was only introduced in WAS 8.0.
			if was8:
				AdminTask.deleteDatasource(datasourceObject)
			else:
				AdminConfig.remove(datasourceObject)
			datasourceObject = ''
		if datasourceObject == '':
			print 'was-install.py creating datasource...'
			if len(properties) == 0:
				# -configureResourceProperties does not accept an empty argument:
				# "WASX8015E: Invalid option value for step configureResourceProperties"
				# -configureResourceProperties does not accept a '[]' argument:
				# java.lang.IllegalArgumentException
				# So, omit the option where there are no properties to configure.
				if authenticationAlias == '':
					AdminTask.createDatasource(
						jdbcProviderObject,
						[
							'-name', datasourceName,
							'-jndiName', jndiName,
							'-dataStoreHelperClassName', dataStoreHelperClassName,
							'-description', description
						]);
				else:
					AdminTask.createDatasource(
						jdbcProviderObject,
						[
							'-name', datasourceName,
							'-jndiName', jndiName,
							'-dataStoreHelperClassName', dataStoreHelperClassName,
							'-description', description,
							'-componentManagedAuthenticationAlias', authenticationAlias
						]);
			else:
				if authenticationAlias == '':
					AdminTask.createDatasource(
						jdbcProviderObject,
						[
							'-name', datasourceName,
							'-jndiName', jndiName,
							'-dataStoreHelperClassName', dataStoreHelperClassName,
							'-configureResourceProperties', properties,
							'-description', description
						]);
				else:
					AdminTask.createDatasource(
						jdbcProviderObject,
						[
							'-name', datasourceName,
							'-jndiName', jndiName,
							'-dataStoreHelperClassName', dataStoreHelperClassName,
							'-configureResourceProperties', properties,
							'-description', description,
							'-componentManagedAuthenticationAlias', authenticationAlias
						]);
		else:
			print 'was-install.py updating datasource...'
			AdminConfig.modify(
				datasourceObject,
				[
					['name', datasourceName],
					['jndiName', jndiName],
					['datasourceHelperClassname', dataStoreHelperClassName],
					['description', description],
					['provider', jdbcProviderObject]
					# ADMG0014E: Attribute providerType is a read-only attribute.
					#['providerType', AdminConfig.showAttribute(jdbcProviderObject, 'providerType')]
				]);
			if authenticationAlias != '':
				AdminConfig.modify(
					datasourceObject,
					[
						['authDataAlias', authenticationAlias]
					]);
			if len(properties) > 0:
				ensureJ2EEResourceProperties(datasourceObject, properties)
		print 'was-install.py modifying datasource properties...'
		datasourceObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/DataSource:' + datasourceName + '/')
		ensureJ2EEResourceProperties(datasourceObject, customProperties)
		print 'was-install.py datasource done'
		print AdminConfig.show(datasourceObject)
		print
		#showJ2EEResourcePropertySet(AdminConfig.showAttribute(datasourceObject, 'propertySet'))

	datasourceName = 'Worklight database'
	description = 'IBM Worklight database'
	jndiName = worklight_database_jndi_name
	database_name = worklight_database_name
	database_jdbc_url = worklight_database_jdbc_url
	database_schema = worklight_database_schema
	ensureDatabase(datasourceName, description, database_selection, jndiName, database_name, database_jdbc_url, database_schema, authenticationAlias)

	datasourceName = 'Worklight reports database'
	description = 'IBM Worklight reports database'
	jndiName = worklightreports_database_jndi_name
	database_name = worklightreports_database_name
	database_jdbc_url = worklightreports_database_jdbc_url
	database_schema = worklightreports_database_schema
	ensureDatabase(datasourceName, description, database_selection, jndiName, database_name, database_jdbc_url, database_schema, authenticationAlias)

	# Ensures a given shared library object exists.
	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftxml_applibrary.html
	def ensureSharedLibrary(sharedLibraryName, description, classpath):
		print 'was-install.py creating shared library...'
		sharedLibraryObject = AdminConfig.getid(scopeContainmentPath + 'Library:' + sharedLibraryName + '/')
		if sharedLibraryObject == '':
			AdminConfig.create('Library', scopeObject, [
				['name', sharedLibraryName],
				['description', description],
				['classPath', classpath],
				['isolatedClassLoader', 'true']
			])
		else:
			AdminConfig.modify(sharedLibraryObject, [
				['description', description],
				['classPath', classpath],
				['isolatedClassLoader', 'true']
			])
		print 'was-install.py creating shared library done'

	sharedLibraryName = 'Worklight Platform Library'
	description = 'IBM Worklight Server Platform Library'
	classpath = '${USER_INSTALL_ROOT}/' + appserver_resourcesdir + '/worklight-jee-library.jar'
	ensureSharedLibrary(sharedLibraryName, description, classpath)

	# Add system property.
	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atservermanagement.html
	# worklight.home is needed because the Worklight server creates data and log
	# files in this location. Without the system property it gets created in the
	# current directory. The value must be unique for each server, so use the
	# value <profileDir>/servers/<server>/worklight.home.
	# Why not ".../WorklightHome" instead of ".../worklight.home"?
	# 1. For consistency with the WAS Liberty and Tomcat installations, where we
	#    don't set worklight.home by default. Here the directory ends up being
	#    named "worklight.home".
	# 2. Because in the server world, unlike in the Windows desktop world, directory
	#    names are usually lower case.

	# Returns the Property object that encodes the JVM system property with the given name.
	def getJVMSystemPropertyObject(name, nodeName, serverName):
		serverObject = AdminConfig.getid('/Cell:' + appserver_was_cell + '/Node:' + nodeName + '/Server:' + serverName + '/')
		# serverObject is of type Server.
		for jvmObject in AdminUtilities.convertToList(AdminConfig.list('JavaVirtualMachine', serverObject)):
			# jvmObject is of type JavaVirtualMachine.
			for propertyObject in AdminUtilities.convertToList(AdminConfig.list('Property', jvmObject)):
				# propertyObject is of type Property.
				if name == AdminConfig.showAttribute(propertyObject, 'name'):
					return propertyObject
		return ''

	# Ensures there is a JVM system property with a given value.
	# If the value is '', the JVM system property setting is removed.
	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atservermanagement.html
	def ensureJVMSystemProperty(name, value):
		print 'was-install.py setting JVM system property ' + name + '...'
		for server in affected_servers:
			(nodeName, serverName) = server
			# In WAS 7, invoking AdminTask.setJVMSystemProperties always creates a
			# new Property object, even if there was already one with the same name.
			propertyObject = getJVMSystemPropertyObject(name, nodeName, serverName)
			if propertyObject == '':
				if value != '':
					AdminTask.setJVMSystemProperties([
						'-nodeName', nodeName,
						'-serverName', serverName,
						'-propertyName', name,
						'-propertyValue', value
					])
			else:
				if value != '':
					AdminConfig.modify(propertyObject, [['value', value]])
				else:
					AdminConfig.remove(propertyObject)
		print 'was-install.py setting JVM system property ' + name + ' done'

	# Use WebSphere variables to define worklight.home, cf.
	# "Creating, editing, and deleting WebSphere variables"
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftcws_variable.html
	worklight_home_dir = '${USER_INSTALL_ROOT}/servers/${WAS_SERVER_NAME}/worklight.home'
	ensureJVMSystemProperty('worklight.home', worklight_home_dir)

	# Add web container custom property.
	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frweb_custom_props.html
	def ensureWebContainerCustomProperty(name, value, description):
		print 'was-install.py setting web container custom property...'
		for server in affected_servers:
			(nodeName, serverName) = server
			serverObject = AdminConfig.getid('/Cell:' + appserver_was_cell + '/Node:' + nodeName + '/Server:' + serverName + '/')
			for webContainerObject in AdminUtilities.convertToList(AdminConfig.list('WebContainer', serverObject)):
				found = False
				for propertyObject in AdminUtilities.convertToList(AdminConfig.list('Property', webContainerObject)):
					if AdminConfig.showAttribute(propertyObject, 'name') == name:
						found = True
						AdminConfig.modify(propertyObject, [
							['value', value],
							['description', description]
						])
				if not found:
					AdminConfig.create('Property', webContainerObject, [
						['name', name],
						['value', value],
						['description', description]
					])
		print 'was-install.py setting web container custom property done'
	# Needed as a workaround to defect 10294.
	# See http://www-01.ibm.com/support/docview.wss?uid=swg1PM50111
	ensureWebContainerCustomProperty('com.ibm.ws.webcontainer.invokeFlushAfterService', 'false', 'See http://www-01.ibm.com/support/docview.wss?uid=swg1PM50111')


	# ==================== Configuration for ApplicationCenter ====================

	datasourceName = 'Application Center database'
	description = 'IBM Worklight Application Center database'
	jndiName = appcenter_database_jndi_name
	database_name = appcenter_database_name
	database_jdbc_url = appcenter_database_jdbc_url
	database_schema = appcenter_database_schema
	ensureDatabase(datasourceName, description, database_selection, jndiName, database_name, database_jdbc_url, database_schema, authenticationAlias)

	# Users and groups.
	# Because "a user registry defined in global security is used to authenticate a user for every application in the cell.", says
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Fcsec_sec_multiple_domains.html
	# we only add new users with hard to guess passwords.
	# We *don't* add users with well-known passwords (like 'appcenteradmin' / 'admin'
	# or 'demo' / 'demo'). This would be a security issue!

	# Convert a string in '[ [ ... ] [ ... ] ]' syntax to a list of lists.
	def convertToListList(s):
		outer = []
		if s[0] == '[' and s[len(s)-1] == ']':
			i = 1
			lbracket = s.find('[', i)
			while lbracket >= 0:
				rbracket = s.index(']', lbracket+1)
				inner = s[lbracket+1:rbracket].split(' ')
				outer.append(inner)
				i = rbracket+1
				lbracket = s.find('[', i)
		return outer

	# Enable application security.
	# This is only possible if administrative security is enabled, see
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftxml_enabledisable.html
	# or "you cannot enable application security without first enabling Global Security at the global level"
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Fcsec_sec_multiple_domains.html
	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atwizardcmds.html
	if AdminTask.isGlobalSecurityEnabled() == 'true':
		print 'was-install.py enabling application security...'
		# Get the previous wizard settings.
		settings = convertToListList(AdminTask.getCurrentWizardSettings())
		# Decompose them.
		secureApps = 'false'
		secureLocalResources = 'false'
		userRegistryType = 'WIMUserRegistry'
		for pair in settings:
			name = pair[0]
			value = pair[1]
			if name == 'secureApps':
				secureApps = value
			elif name == 'secureLocalResources':
				secureLocalResources = value
			elif name == 'userRegistryType':
				userRegistryType = value
		# Set secureApps to true.
		if secureApps != 'true':
			secureApps = 'true'
			AdminTask.applyWizardSettings([
				'-secureApps', secureApps,
				'-secureLocalResources', secureLocalResources,
				'-userRegistryType', userRegistryType,
				'-adminName', appserver_was_admin_name
			])
		# Alternative implementation:
		#securityObject = AdminConfig.list('Security');
		#if securityObject != '':
		#	AdminConfig.modify(securityObject, [['appEnabled', 'true']])
		print 'was-install.py enabling application security done'

	# If the custom panels have told the user that an account 'appcenteradmin' will
	# be created, do so now.
	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atwimmgt.html
	if appserver_was_appcenteradmin_password != '':
		print 'was-install.py adding appcenteradmin user...'
		if AdminTask.searchUsers(['-uid', 'appcenteradmin']) == '':
			try:
				AdminTask.createUser([
					'-uid', 'appcenteradmin',
					'-cn', 'Administrator',
					'-sn', 'of IBM Application Center',
					'-password', appserver_was_appcenteradmin_password
				])
			except:
				# Catch exception when administrative security is not enabled:
				# "com.ibm.websphere.wim.exception.WIMApplicationException:
				# CWWIM5505E To manage users and groups, either federated repositories
				# must be the current realm definition or the current realm definition
				# configuration must match the federated repositories configuration.
				# If you use Lightweight Directory Access Protocol (LDAP), configure
				# both the federated repositories and standalone LDAP registry
				# configurations to use the same LDAP server."
				pass
		print 'was-install.py adding appcenteradmin user done'

	# Use WebSphere variables to define android.aapt.dir, cf.
	# "Creating, editing, and deleting WebSphere variables"
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftcws_variable.html
	ensureJVMSystemProperty('android.aapt.dir', '${USER_INSTALL_ROOT}/' + appserver_was_aapt_dir)

	# Save the changes done so far.
	AdminConfig.save()


	# ================= Install Worklight console web application =================

	# Install an application, given as a war file.
	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftxml_callappinstall.html
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_adminapp.html
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_taskoptions.html
	# otherOptions is a list of options (key-value pairs in a single list of even length).
	def installApplication(war, war_basename, war_context, war_appname, otherOptions):
		print 'was-install.py installing ' + war_basename + '...'
		# Collect the options.
		options = []
		options.append('-cell'); options.append(appserver_was_cell)
		if appserver_was_scope == 'server':
			options.append('-node'); options.append(appserver_was_node)
			options.append('-server'); options.append(appserver_was_serverInstance)
			# Apparently redundant.
			#options.append('-target'); options.append('WebSphere:cell=' + appserver_was_cell + ',node=' + appserver_was_node + ',server=' + appserver_was_serverInstance)
		elif appserver_was_scope == 'nd-cell':
			# Here the '-target' option is necessary: without it, the application
			# gets installed in the deployment manager.
			# In the '-target' option, we cannot list servers that are members of some cluster:
			# It produces an error
			# "The target server ... specified for "+war_basename+"+WEB-INF/web.xml is a part of cluster ..., but cluster ... is not specified in the list of targets."
			# Therefore we have to specify all clusters and, separately, all servers
			# that are not members of any cluster.
			targets = []
			for clusterObject in AdminUtilities.convertToList(AdminConfig.list('ServerCluster')):
				# clusterObject is of type ServerCluster.
				name = AdminConfig.showAttribute(clusterObject, 'name')
				if name != '':
					targets.append('WebSphere:cell=' + appserver_was_cell + ',cluster=' + name)
			for server in affected_servers:
				(nodeName, serverName) = server
				if not isInCluster(nodeName, serverName):
					targets.append('WebSphere:cell=' + appserver_was_cell + ',node=' + nodeName + ',server=' + serverName)
			options.append('-target'); options.append('+'.join(targets))
		elif appserver_was_scope == 'nd-cluster':
			options.append('-cluster'); options.append(appserver_was_nd_cluster)
			# Apparently redundant.
			#options.append('-target'); options.append('WebSphere:cell=' + appserver_was_cell + ',cluster=' + appserver_was_nd_cluster)
		elif appserver_was_scope == 'nd-node':
			options.append('-node'); options.append(appserver_was_nd_node)
			# Here the '-target' option is necessary to avoid a "No valid target is specified in ObjectName" error.
			# And servers that are members of some cluster have been excluded from affected_servers, to avoid an error
			# "The target server ... specified for "+war_basename+"+WEB-INF/web.xml is a part of cluster ..., but cluster ... is not specified in the list of targets."
			targets = []
			for server in affected_servers:
				(nodeName, serverName) = server
				targets.append('WebSphere:cell=' + appserver_was_cell + ',node=' + nodeName + ',server=' + serverName)
			options.append('-target'); options.append('+'.join(targets))
		elif appserver_was_scope == 'nd-server':
			options.append('-node'); options.append(appserver_was_nd_node)
			options.append('-server'); options.append(appserver_was_nd_server)
			# Apparently redundant.
			#options.append('-target'); options.append('WebSphere:cell=' + appserver_was_cell + ',node=' + appserver_was_nd_node + ',server=' + appserver_was_nd_server)
		options.append('-contextroot'); options.append(war_context)
		options.append('-appname'); options.append(war_appname)
		# The options '-MapModulesToServers' [[war_basename, war_basename+',WEB-INF/web.xml', targets]]
		# are apparently redundant.
		for argument in otherOptions:
			options.append(argument)
		# Avoid error "ADMA0010E: Validation error in task Selecting virtual hosts for Web modules. A virtual host is not specified"
		options.append('-usedefaultbindings')
		# Perform the call.
		AdminApp.install(war, options)
		print 'was-install.py installing ' + war_basename + ' done'

	installApplication(
		worklight_war, worklight_war_basename, worklight_war_context,
		worklight_war_appname,
		[
			'-MapSharedLibForMod', [[worklight_war_appname, 'META-INF/application.xml', sharedLibraryName]]
		])

	# -------- Set classloader mode for Worklight console web application --------

	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Fcrun_classload.html

	def ensureClassLoaderModeIsParentLast(appname):
		print 'was-install.py setting classloader mode for ' + appname + '...'
		# Verify that the server does not override the application-level classloader mode.
		# Keep this check consistent with the one done in the custom panels!
		for applicationServerObject in AdminUtilities.convertToList(AdminConfig.list('ApplicationServer', scopeObject)):
			# applicationServerObject is of type ApplicationServer.
			# For WAS ND, exclude the ApplicationServer that belongs to the deployment manager.
			serverObject = AdminConfig.showAttribute(applicationServerObject, 'server')
			# serverObject is of type Server.
			if AdminConfig.showAttribute(serverObject, 'serverType') == 'APPLICATION_SERVER':
				if AdminConfig.showAttribute(applicationServerObject, 'applicationClassLoaderPolicy') == 'SINGLE':
					if AdminConfig.showAttribute(applicationServerObject, 'applicationClassLoadingMode') == 'PARENT_FIRST':
						serverName = AdminConfig.showAttribute(serverObject, 'name')
						raise 'inappropriate server settings: server ' + serverName + ' has applicationClassLoaderPolicy = SINGLE and applicationClassLoadingMode = PARENT_FIRST'
		deploymentObject = AdminConfig.getid('/Deployment:'+appname+'/')
		if deploymentObject != '':
			# deploymentObject is not a list, because WAS guarantees that there is at most one application with a given name.
			# deploymentObject is of type Deployment.
			applicationDeploymentObject = AdminConfig.showAttribute(deploymentObject, 'deployedObject')
			if applicationDeploymentObject != '':
				# applicationDeploymentObject is of type ApplicationDeployment.
				# Set the classloader mode for the application to "Parent classloader last".
				classloaderObject = AdminConfig.showAttribute(applicationDeploymentObject, 'classloader')
				AdminConfig.modify(classloaderObject, [['mode', 'PARENT_LAST']])
				# Set the Class loader order of all modules to "Parent classloader last".
				for moduleObject in AdminUtilities.convertToList(AdminConfig.showAttribute(applicationDeploymentObject, 'modules')):
					# XXX Only if moduleObject.find('#WebModuleDeployment_') >= 0 ??
					AdminConfig.modify(moduleObject, [['classloaderMode', 'PARENT_LAST']])
		print 'was-install.py setting classloader mode for ' + appname + ' done'

	ensureClassLoaderModeIsParentLast(worklight_war_appname)

	# ================= Install ApplicationCenter web applications =================

	installApplication(
		appcenter_console_war, appcenter_console_war_basename, appcenter_console_war_context,
		appcenter_console_war_appname,
		[
			# XXX Not sure whether we need to add the appcenteradmin user name here.
			'-MapRolesToUsers', [['appcenteradmin', 'No', 'Yes', '', '']]
		])

	installApplication(
		appcenter_services_war, appcenter_services_war_basename, appcenter_services_war_context,
		appcenter_services_war_appname,
		[
			# XXX Not sure whether we need to add the appcenteradmin user name here.
			'-MapRolesToUsers', [['appcenteradmin', 'No', 'Yes', '', '']]
		])

	# -------- Set classloader mode for ApplicationCenter web applications --------

	# Without this, the ApplicationCenter web applications does not start, due to
	# java.lang.ClassCastException: org.jboss.resteasy.spi.ResteasyProviderFactory incompatible with javax.ws.rs.ext.RuntimeDelegate
	ensureClassLoaderModeIsParentLast(appcenter_console_war_appname)
	ensureClassLoaderModeIsParentLast(appcenter_services_war_appname)


	# Save the changes done so far.
	AdminConfig.save()


	# ======================== Start the web applications ========================

	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftxml_startapplication.html
	def startApplication(war_basename, war_appname):
		print 'was-install.py starting ' + war_basename + '...'
		# If appserver_was_scope is 'server' or 'nd-node' or 'nd-server',
		# it would be sufficient to make a single AdminControl.queryNames
		# call and iterate over the result. But this approach does not work
		# if appserver_was_scope is 'nd-cell' (the result contains also
		# the deployment manager process) or 'nd-cluster'.
		# Therefore loop over the predetermined set of servers.
		for server in affected_servers:
			(nodeName, serverName) = server
			appManager = AdminControl.queryNames('type=ApplicationManager,'
							     + 'cell=' + appserver_was_cell + ','
							     + 'node=' + nodeName + ','
							     + 'process=' + serverName + ','
							     + '*')
			# If the server is not running, appManager is empty.
			# Then the application will be started when the server starts.
			if appManager != '':
				AdminControl.invoke(appManager, 'startApplication', war_appname)
		print 'was-install.py starting ' + war_basename + ' done'

	# Does not work in WAS ND:
	# It leads to "com.ibm.ws.exception.ConfigurationWarning: Application ... not installed"
	# error during startApplication. A fullSync() and a time.sleep(10) don't help.
	# TODO Need to restart the application servers? Or play with isAppReady and getDeployStatus?
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.nd.doc%2Finfo%2Fae%2Fae%2Ftxml_callappinstall.html
	# Consider also
	# http://www-01.ibm.com/support/docview.wss?uid=swg21572889
	# http://www-01.ibm.com/support/docview.wss?uid=swg21161426
	if appserver_was_scope[0:3] != 'nd-':
		startApplication(worklight_war_basename, worklight_war_appname)
		# Start ApplicationCenter web applications in bottom-up order.
		startApplication(appcenter_services_war_basename, appcenter_services_war_appname)
		startApplication(appcenter_console_war_basename, appcenter_console_war_appname)


	# ==================================== Done ===================================


if operation == 'uninstall':


	# ======================== Stop the web applications ========================

	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftxml_stopapplication.html
	def stopApplication(war_basename, war_appname):
		print 'was-install.py stopping ' + war_basename + '...'
		for server in affected_servers:
			(nodeName, serverName) = server
			appManager = AdminControl.queryNames('type=ApplicationManager,'
							     + 'cell=' + appserver_was_cell + ','
							     + 'node=' + nodeName + ','
							     + 'process=' + serverName + ','
							     + '*')
			# If the server is not running, appManager is empty.
			if appManager != '':
				try:
					AdminControl.invoke(appManager, 'stopApplication', war_appname)
				except:
					# Catch "com.ibm.ws.exception.RuntimeWarning: Application ... not started"
					pass
		print 'was-install.py stopping ' + war_basename + ' done'

	stopApplication(worklight_war_basename, worklight_war_appname)

	stopApplication(appcenter_console_war_basename, appcenter_console_war_appname)

	stopApplication(appcenter_services_war_basename, appcenter_services_war_appname)


	# ====================== Uninstall the web applications ======================

	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Ftxml_uninstall.html
	def uninstallApplication(war_basename, war_appname):
		print 'was-install.py uninstalling ' + war_basename + '...'
		try:
			AdminApp.uninstall(war_appname)
		except:
			# Catch "com.ibm.ws.scripting.ScriptingException: WASX7280E: An application with name ... does not exist."
			pass
		print 'was-install.py uninstalling ' + war_basename + ' done'

	uninstallApplication(worklight_war_basename, worklight_war_appname)

	uninstallApplication(appcenter_console_war_basename, appcenter_console_war_appname)

	uninstallApplication(appcenter_services_war_basename, appcenter_services_war_appname)


	# ========================== Delete the datasources ==========================

	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v8r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atjdbcprovider.html
	# AdminTask.deleteDatasource was only introduced in WAS 8.0.

	# Delete a datasource.
	def deleteDatasource(jdbcProviderName, jdbcProviderObject, datasourceName):
		print 'was-install.py deleting datasource...'
		datasourceObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/DataSource:' + datasourceName + '/')
		if datasourceObject != '':
			# AdminTask.deleteDatasource was only introduced in WAS 8.0.
			if was8:
				AdminTask.deleteDatasource(datasourceObject)
			else:
				AdminConfig.remove(datasourceObject)
		print 'was-install.py deleting datasource done'

	jdbcProviderName = 'Worklight JDBC Provider'
	jdbcProviderObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/')
	if jdbcProviderObject != '':
		datasourceName = 'Worklight database'
		deleteDatasource(jdbcProviderName, jdbcProviderObject, datasourceName)
		datasourceName = 'Worklight reports database'
		deleteDatasource(jdbcProviderName, jdbcProviderObject, datasourceName)
		datasourceName = 'Application Center database'
		deleteDatasource(jdbcProviderName, jdbcProviderObject, datasourceName)

	# Also delete leftovers from previous release (<= 5.0.0.3).
	jdbcProviderName = 'Application Center JDBC Provider'
	jdbcProviderObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/')
	if jdbcProviderObject != '':
		datasourceName = 'Application Center database'
		deleteDatasource(jdbcProviderName, jdbcProviderObject, datasourceName)


	# ========================= Delete the JDBC providers =========================

	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v8r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atjdbcprovider.html

	# Delete a JDBC provider.
	def deleteJDBCProvider(jdbcProviderName):
		print 'was-install.py deleting JDBC provider...'
		jdbcProviderObject = AdminConfig.getid(scopeContainmentPath + 'JDBCProvider:' + jdbcProviderName + '/')
		if jdbcProviderObject != '':
			# AdminTask.deleteJDBCProvider was only introduced in WAS 8.0.
			if was8:
				AdminTask.deleteJDBCProvider(jdbcProviderObject)
			else:
				AdminConfig.remove(jdbcProviderObject)
		print 'was-install.py deleting JDBC provider done'

	jdbcProviderName = 'Worklight JDBC Provider'
	deleteJDBCProvider(jdbcProviderName)

	# Also delete leftovers from previous release (<= 5.0.0.3).
	jdbcProviderName = 'Application Center JDBC Provider'
	deleteJDBCProvider(jdbcProviderName)


	# ======================= Delete authentication aliases =======================

	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_7securityconfig.html

	# Deletes the authentication alias with the given name.
	def deleteAuthAliasBAD(name):
		# Using AdminTask.deleteAuthDataEntry is bad because
		# - It leaves an exception in the log if the entry does not exist.
		# - In WAS 7.0, when invoked with argument ['-alias', name], the
		#   function may delete the alias with name node+'/'+name.
		try:
			AdminTask.deleteAuthDataEntry(['-alias', name])
		except:
			# Note: This leaves an exception
			#   FFDC Exception:com.ibm.websphere.management.cmdframework.CommandValidationException
			#   SECJ7732E: The specified auth data entry does not exist.
			# in the server's log, but it can be ignored.
			pass
	def deleteAuthAlias(name):
		# Use AdminConfig.
		entryObject = getAuthDataEntryObject(name)
		if entryObject != '':
			# entryObject is of type JAASAuthData.
			AdminConfig.remove(entryObject)

	print 'was-install.py delete authentication alias...'
	if authenticationAlias != '':
		deleteAuthAlias(authenticationAlias)
	print 'was-install.py delete authentication alias done'


	# =========================== Delete user accounts ===========================

	# Documentation:
	# http://pic.dhe.ibm.com/infocenter/wasinfo/v7r0/index.jsp?topic=%2Fcom.ibm.websphere.base.doc%2Finfo%2Faes%2Fae%2Frxml_atwimmgt.html

	if appserver_was_appcenteradmin_password != '':
		print 'was-install.py delete appcenteradmin user...'
		try:
			AdminTask.deleteUser(['-uniqueName', 'uid=appcenteradmin,o=defaultWIMFileBasedRealm'])
		except:
			pass
		print 'was-install.py delete appcenteradmin user done'


	# ======================== Delete JVM system property ========================

	# Returns the Property object that encodes the JVM system property with the given name.
	def getJVMSystemPropertyObject(name, nodeName, serverName):
		serverObject = AdminConfig.getid('/Cell:' + appserver_was_cell + '/Node:' + nodeName + '/Server:' + serverName + '/')
		for jvmObject in AdminUtilities.convertToList(AdminConfig.list('JavaVirtualMachine', serverObject)):
			for propertyObject in AdminUtilities.convertToList(AdminConfig.list('Property', jvmObject)):
				if name == AdminConfig.showAttribute(propertyObject, 'name'):
					return propertyObject
		return ''

	# Removes a given JVM system property.
	def deleteJVMSystemPropertyObject(name):
		for server in affected_servers:
			(nodeName, serverName) = server
			propertyObject = getJVMSystemPropertyObject(name, nodeName, serverName)
			if propertyObject != '':
				AdminConfig.remove(propertyObject)

	deleteJVMSystemPropertyObject('worklight.home')


	# ========================== Delete shared libraries ==========================

	sharedLibraryName = 'Worklight Platform Library'
	print 'was-install.py delete shared library...'
	sharedLibraryObject = AdminConfig.getid(scopeContainmentPath + 'Library:' + sharedLibraryName + '/')
	if sharedLibraryObject != '':
		AdminConfig.remove(sharedLibraryObject)
	print 'was-install.py delete shared library done'


	# ======================== Delete JVM system property ========================

	deleteJVMSystemPropertyObject('android.aapt.dir')


	# ==================================== Done ===================================


# Finally save all the changes.
AdminConfig.save()

if appserver_was_scope[0:3] == 'nd-':
	# Execute a "full synchronize" of the configuration to all nodes.
	fullSync()

